/****************************************************************************
* PROJECT       : CS-541, PascalD to PS project
* FILE_NAME     : hash.cc
* PROGRAMMER    : provided by teacher (JWJ)
*
* SYNOPSIS      : include hash.h to use these functions.
*
* DESCRIPTION   : Contains the hash function for the symbol table.
*
*               hash() - compute a hash value.
*
****************************************************************************/

#include "hash.h"

/****************************************************************************
* FUNCTION_NAME : insert()
* INPUT         : A key and a hash table size.
* OUTPUT        : a hash value for the key.
*                 Parameters:
*                 char *Key, the Key to hash on.
*                 cost int H_Size, the size of the hash table being used.
* VALUE RETURNED: A hash value for the key given to the function.
* DESCRIPTION   : A token hashing function.
****************************************************************************/
int token_hash(char *Key, const int H_Size)
{
        char *Key_Ptr = Key;
        unsigned int Hash_Val = 0;
        unsigned int g;

        while(*Key_Ptr) {
             Hash_Val = (Hash_Val << 4) + *Key_Ptr++;
             g = Hash_Val & 0xF0000000;
             if (g) Hash_Val ^= g >> 24;
             Hash_Val &= ~g;
        }

        return Hash_Val % H_Size;
}
