#ifndef RDPARSER_H
#define RDPARSER_H
#include "rddefs.h"
#include "rdtoken.h"

class RdParser {
	RdToken *rdtoken;
public:
	RdParser();
	~RdParser();
	rdunion rdparse();
	rdunion parseProgram(rdunion *retval);
	rdunion parseBlock(rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseAllDeclaration(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseDeclarations(rdunion *inherit6, rdunion *inherit5, rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIdentifierList(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIdListTail(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseType(rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseStandardType(rdunion *inherit8, rdunion *inherit7, rdunion *inherit6, rdunion *inherit5, rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseSubprogramDeclarations(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseSubprogramDeclaration(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseSubprogramHead(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseArguments(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseParameterList(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseParameterTail(rdunion *inherit5, rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseCompoundStatement(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseOptionalStatement(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseStatementList(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseStatementListTail(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseStatement(rdunion *inherit7, rdunion *inherit6, rdunion *inherit5, rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseStatementOp(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseOptionalAssign(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseAssignStatement(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseWriteStatement(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseWriteLnStatement(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseReadStatement(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIdRList(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIdRTail(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIndex(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIndexType(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIdAccess(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIdAccessTail(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseWhileStatement(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseForStatement(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseIfStatement(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseTestelse(rdunion *inherit5, rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseProcTail(rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseProcExpressionList(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseProcExpressionListTail(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseExpression(rdunion *inherit5, rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseExpressionTail(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseSimpleExpression(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseSimpleExpressionTail(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseTerm(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseSign(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseTermTail(rdunion *inherit4, rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseFactor(rdunion *inherit3, rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
	rdunion parseFactorOp(rdunion *inherit2, rdunion *inherit1, rdunion *inherit0, rdunion *retval);
};
#endif
